<?php
// https://understanddrupal.com/articles/how-debug-drupal-migrations-part-2

namespace Drupal\popsu_migrate\Plugin\migrate\source;

use Drupal\migrate\Row;
use Drush\Drush;

// use Drupal\popsu_migrate\Plugin\migrate\source\D7Programme;

/**
 * Drupal 7 node source from database.
 *
 * @MigrateSource(
 *   id = "d7_paragraphe_texts_programme",
 *   source_module = "node"
 * )
 */
class D7PargrapheTextsProgramme extends D7Programme {

  /**
   * {@inheritdoc}
   */
  public function prepareRow(Row $row) {
    $nid = $row->getSourceProperty('nid');
    $vid = $row->getSourceProperty('vid');
    $type = $row->getSourceProperty('type');

    // Get Field API field values.
    foreach ($this->getFields('node', $type) as $field_name => $field) {
      $row->setSourceProperty($field_name, $this->getFieldValues('node', $field_name, $nid, $vid, NULL));
    }

    // texts
    $text = $row->getSourceProperty('field_popsu_special_text');
    $row->setSourceProperty('text', $text[0]['value']);
    $row->setSourceProperty('text_summary', $text[0]['summary']);

    return parent::prepareRow($row);
  }

}
